# Randomer Forest (RerF) Python Package

[![PyPI version](https://badge.fury.io/py/rerf.svg)](https://badge.fury.io/py/rerf)

Randomer Forest combines sparse random projections with the random forest algorithm to achieve high accuracy on a variety of datasets.

Documentation for RerF Python module can be found at [rerf.neurodata.io](https://rerf.neurodata.io).

## Install

See install [instructions](https://rerf.neurodata.io/install.html).

## Example

See [example](https://github.com/neurodata/RerF/blob/staging/Python/examples/example_rerfClassifier.py) for basic usage.

## Reference

Function references can be found in our [docs](https://rerf.neurodata.io/reference.html).

## Tests

We use [pytest](https://docs.pytest.org/en/latest/) for Python testing.

Run the tests from command line at the root of the repo (`RerF/`).

```sh
python -m pytest
```

## Publish new version

To upload to [PyPi](https://pypi.org) see [PUBLISH.md](PUBLISH.md)